#ifndef __DLPROTOS__
#define __DLPROTOS__

#ifndef __APPLEEVENTS__
#include <AppleEvents.h>
#endif

#ifndef __APPLETALK__
#include <AppleTalk.h>
#endif

#ifndef __LISTS__
#include <Lists.h>
#endif

#ifndef __MENUS__
#include <Menus.h>
#endif

#ifndef __PPCTOOLBOX__
#include <PPCToolbox.h>
#endif

#ifndef __STANDARDFILE__
#include <StandardFile.h>
#endif


/************** AEConnect.c **************/

void			InitConnectAppleEvents(void);
OSErr			SendConnect(FileRecHndl frHndl, char *theLocNBPType);
WindowPtr		GetAEWindow(long windID_0, long windID_1);



/************** AERequired.c **************/

OSErr			InitRequiredAppleEvents(void);



/************** AEUtils.c **************/

#ifndef         __AEUTILS__
#include		"AEUtils.h"
#endif



/************** AEWFMT.c **************/

void	InitWFMTAppleEvents(void);
OSErr	SendWFMTMessage(FileRecHndl frHndl, TreeObjHndl wobj, short messageType,
						ResType rtype, short resID, Handle *resHndl);



/************** ATUtils.c **************/

#ifndef         __ATUTILS__
#include		"ATUtils.h"
#endif



/************** CIconControl.c **************/

#ifndef         __CICONCONTROL__
#include		"CIconControl.h"
#endif



/************** CtlHandler.c **************/

#ifndef         __CTLHANDLER__
#include		"CtlHandler.h"
#endif



/************** DoEvent.c **************/

void			DoEvent(EventRecord *event);

/*  DTS.Lib..framework calls these.  */
void			DoActivate(WindowPtr window);
void			DoCursor(void);



/************** File.c **************/

/*  DTS.Lib..framework calls these.  */
OSErr			InitDocument(FileRecHndl frHndl);
long			InitDocumentSize(OSType sftype);



/************** File2.c **************/

OSErr			DefaultInitDocument(FileRecHndl frHndl, short version,
									short numUndos, short numSaveUndos);
OSErr			DisposeDocument(FileRecHndl frHndl);
OSErr			NewDocument(FileRecHndl *returnHndl, OSType sftype, Boolean incTitleNum);
OSErr			OpenDocument(FileRecHndl *result, FSSpecPtr fileToOpen, char permission);
OSErr			SaveDocument(FileRecHndl frHndl, WindowPtr window, short saveMode);
void			ConvertOldToNewSFReply(SFReply *oldReply, StandardFileReply *newReply);
Boolean			DisplayGetFile(StandardFileReply *reply, short typeListLen, SFTypeList typeList);
Boolean			DisplayPutFile(StandardFileReply *reply);
OSErr			UseDocResFile(FileRecHndl frHndl, short *oldRes, char perm);
OSErr			CloseDocResFile(FileRecHndl frHndl);
long			GetModNum(void);
Boolean			GetDocDirty(FileRecHndl frHndl);
Boolean			GetWindowDirty(WindowPtr window);
void			SetDocDirty(FileRecHndl frHndl);
void			SetWindowDirty(WindowPtr window);
OSErr			SetDefault(short newVRefNum, long newDirID, short *oldVRefNum, long *oldDirID);
OSErr			RestoreDefault(short oldVRefNum, long oldDirID);

OSErr			GetFileLocation(short refNum, short *vRefNum, long *dirID, StringPtr fileName);



/************** Init.c **************/

void			Initialize(short moreMasters, long minHeap, long minSpace,
						   ProcPtr init1, ProcPtr init2);
void			StartDocuments(void);



/************** GWLayers.c **************/

#ifndef         __GWLAYERS__
#include		"GWLayers.h"
#endif



/************** ListControl.c **************/

#ifndef         __LISTCONTROL__
#include		"ListControl.h"
#endif



/************** Menu.c **************/

/*  DTS.Lib..framework calls these.  */
void			DoAdjustMenus(void);
Boolean			DoMenuCommand(short menuID, short menuItem);



/************** PICTControl.c **************/

#ifndef         __PICTCONTROL__
#include		"PICTControl.h"
#endif



/************** PPC.c **************/

#ifndef         __PPC__
#include		"PPC.h"
#endif



/************** Print.c **************/

OSErr			PrintDocument(FileRecHndl frHndl, Boolean jobDlg, Boolean firstJob);
void			DonePrinting(void);
OSErr			PresentStyleDialog(FileRecHndl frHndl);



/************** TextEditControl.c **************/

#ifndef         __TEXTEDITCONTROL__
#include		"TextEditControl.h"
#endif



/************** TreeObj.c **************/

#ifndef         __TREEOBJ__
#include		"TreeObj.h"
#endif



/************** ViewHierarchy.c **************/

OSErr			VHInitDocument(FileRecHndl frHndl);
long			VHFileTypeSize(void);
void			VHRootInfo(TreeObjHndl root, char *cptr);
void			VHFileRecInfo(TreeObjHndl root, char *cptr);



/************** Window2.c **************/

OSErr			DoNewWindow(FileRecHndl frHndl, WindowPtr *retWindow,
							WindowPtr relatedWindow, WindowPtr behind);
void			NewWindowTitle(WindowPtr window, StringPtr altTitle);
Boolean			DisposeAllWindows(void);
Boolean			DisposeOneWindow(WindowPtr window, short saveMode);
WindowPtr		SetFilePort(FileRecHndl frHndl);
void			DoResizeWindow(WindowPtr window, short oldh, short oldv);
void			DoUpdateSeparate(WindowPtr window, RgnHandle *contRgn, RgnHandle *frameRgn);
void			BeginContent(WindowPtr window);
void			EndContent(WindowPtr window);
void			BeginFrame(WindowPtr window);
void			EndFrame(WindowPtr window);
void			AdjustScrollBars(WindowPtr window);
void			GetContentOrigin(WindowPtr window, Point *contOrg);
void			SetContentOrigin(WindowPtr window, long newh, long newv);
void			GetContentRect(WindowPtr window, Rect *contRct);
void			SetDocSize(FileRecHndl frHndl, long hSize, long vSize);
void			SetSidebarSize(FileRecHndl frHndl, short newLeft, short newTop);
void			SetScrollIndentSize(FileRecHndl frHndl, short newh, short newv);
FileRecHndl		GetNextDocument(WindowPtr window, OSType sftype);
WindowPtr		GetNextWindow(WindowPtr window, OSType sftype);
WindowPtr		GetPreviousWindow(WindowPtr window);
void			DoZoomWindow(WindowPtr window, EventRecord *event, short zoomDir);
RgnHandle		DoCalcFrameRgn(WindowPtr window);
RgnHandle		DoCalcScrollRgn(WindowPtr window);
void			DoContentClick(WindowPtr window, EventRecord *event, Boolean firstClick);
void			DoDragWindow(WindowPtr window, EventRecord *event, Rect bounds);
void			DoDrawFrame(WindowPtr window, Boolean activate);
OSErr			DoFreeDocument(FileRecHndl frHndl);
OSErr			DoFreeWindow(FileRecHndl frHndl, WindowPtr window);
OSErr			DoImageDocument(FileRecHndl frHndl);
OSErr			DoInitContent(FileRecHndl frHndl, WindowPtr window);
Boolean			DoKeyDown(EventRecord *event);
void			DoMouseDown(EventRecord *event);
short			MapMItem(short menuID, short menuItem);
short			UnmapMItem(short menuID, short menuItem);
OSErr			DefaultFreeDocument(FileRecHndl frHndl);
OSErr			DoReadDocument(FileRecHndl frHndl);
OSErr			DoReadDocumentHeader(FileRecHndl frHndl);
OSErr			DefaultReadDocument(FileRecHndl frHndl);
OSErr			DefaultReadDocumentHeader(FileRecHndl frHndl);
OSErr			DefaultReadDocumentFixup(FileRecHndl frHndl);
OSErr			DoWriteDocument(FileRecHndl frHndl);
OSErr			DoWriteDocumentHeader(FileRecHndl frHndl);
OSErr			DefaultWriteDocument(FileRecHndl frHndl);
OSErr			DefaultWriteDocumentHeader(FileRecHndl frHndl);
void			DoResizeContent(WindowPtr window, short oldh, short oldv);
void			DoScrollFrame(WindowPtr window, long dh, long dv);
void			DoUndoFixup(FileRecHndl frHndl, Point contOrg, Boolean afterUndo);
WindowPtr		GetOldLocWindow(short id, Ptr storage, Boolean vis, WindowPtr relWindow,
								WindowPtr behind, Boolean inColor, Rect sizeInfo, long refCon);
void			CleanSendBehind(WindowPtr window, WindowPtr afterWindow);
void			CleanSendInFront(WindowPtr window, WindowPtr beforeWindow);
void			HiliteWindows(void);
void			UnhiliteWindows(void);
void			DoUpdate(WindowPtr window);
void			DoSetCursor(Cursor *cursor);
CursPtr			DoSetResCursor(short crsrID);
void			DoWindowCursor(void);
WindowPtr		FrontWindowOfType(long wkind, Boolean firstVis);
short			HCenteredAlert(short alertID, WindowPtr relatedWindow, ModalFilterProcPtr filter);
OSErr			GetWindowFormats(void);
OSErr			HReadWindowFormats(Handle wfmt);
OSErr			AddControlSet(WindowPtr window, OSType sftype, short visMode,
							  short xoffset, short yoffset, CObjCtlHndl cco);
CObjCtlHndl		GetControlSet(WindowPtr window, OSType sftype, ControlHandle *retDataCtl);
void			DisplayControlSet(WindowPtr window, OSType sftype, short visMode);
void			DisposeControlSet(WindowPtr window, OSType sftype);
Boolean			DoAdjustMBARMenus(WindowPtr window, short menuBarID);
OSErr			OpenRuntimeOnlyAutoNewWindows(void);
OSErr			NewDocumentWindow(FileRecHndl *frHndl, OSType sftype, Boolean incTitleNum);
OSErr			OpenDocumentWindow(FileRecHndl *frHndl, FSSpecPtr fileToOpen, char permission);



/************** Window.c **************/

/*  DTS.Lib..framework calls these.  */
void			CalcFrameRgn(FileRecHndl frHndl, WindowPtr window, RgnHandle rgn);
void			ContentClick(WindowPtr window, EventRecord *event, Boolean firstCLick);
Boolean			ContentKey(WindowPtr window, EventRecord *event, Boolean *passThrough);
void			DrawFrame(FileRecHndl frHndl, WindowPtr window, Boolean activate);
OSErr			FreeDocument(FileRecHndl frHndl);
OSErr			FreeWindow(FileRecHndl frHndl, WindowPtr window);
OSErr			ImageDocument(FileRecHndl frHndl);
OSErr			InitContent(FileRecHndl frHndl, WindowPtr window);
OSErr			ReadDocument(FileRecHndl frHndl);
void			ResizeContent(WindowPtr window, short oldh, short oldv);
void			ScrollFrame(FileRecHndl frHndl, WindowPtr window, long dh, long dv);
void			UndoFixup(FileRecHndl frHndl, Point contOrg, Boolean afterUndo);
Boolean			WindowCursor(FileRecHndl frHndl, WindowPtr window, Point globalPt);
void			WindowGoneFixup(WindowPtr window);
OSErr			WriteDocument(FileRecHndl frHndl);
OSErr			DoOpenApplication(void);
Boolean			AdjustMenuItems(WindowPtr window, short menuID);
Boolean			DoMenuItem(WindowPtr window, short menuID, short menuItem);



/************** WindowDialog.c **************/

/*  DTS.Lib..framework calls these.  */
void			DialogCalcFrameRgn(FileRecHndl frHndl, WindowPtr window, RgnHandle rgn);
void			DialogContentClick(WindowPtr window, EventRecord *event, Boolean firstCLick);
Boolean			DialogContentKey(WindowPtr window, EventRecord *event, Boolean *passThrough);
void			DialogDrawFrame(FileRecHndl frHndl, WindowPtr window, Boolean activate);
OSErr			DialogFreeDocument(FileRecHndl frHndl);
OSErr			DialogFreeWindow(FileRecHndl frHndl, WindowPtr window);
OSErr			DialogImageDocument(FileRecHndl frHndl);
OSErr			DialogInitContent(FileRecHndl frHndl, WindowPtr window);
void			DialogResizeContent(WindowPtr window, short oldh, short oldv);
void			DialogScrollFrame(FileRecHndl frHndl, WindowPtr window, long dh, long dv);
void			DialogUndoFixup(FileRecHndl frHndl, Point contOrg, Boolean afterUndo);
Boolean			DialogWindowCursor(FileRecHndl frHndl, WindowPtr window, Point globalPt);
void			DialogWindowGoneFixup(WindowPtr window);
Boolean			DialogAdjustMenuItems(WindowPtr window, short menuID);
Boolean			DialogDoMenuItem(WindowPtr window, short menuID, short menuItem);


/************** WindowPalette.c **************/

/*  DTS.Lib..framework calls these.  */
void			PaletteCalcFrameRgn(FileRecHndl frHndl, WindowPtr window, RgnHandle rgn);
void			PaletteContentClick(WindowPtr window, EventRecord *event, Boolean firstCLick);
Boolean			PaletteContentKey(WindowPtr window, EventRecord *event, Boolean *passThrough);
void			PaletteDrawFrame(FileRecHndl frHndl, WindowPtr window, Boolean activate);
OSErr			PaletteFreeDocument(FileRecHndl frHndl);
OSErr			PaletteFreeWindow(FileRecHndl frHndl, WindowPtr window);
OSErr			PaletteImageDocument(FileRecHndl frHndl);
OSErr			PaletteInitContent(FileRecHndl frHndl, WindowPtr window);
void			PaletteResizeContent(WindowPtr window, short oldh, short oldv);
void			PaletteScrollFrame(FileRecHndl frHndl, WindowPtr window, long dh, long dv);
void			PaletteUndoFixup(FileRecHndl frHndl, Point contOrg, Boolean afterUndo);
Boolean			PaletteWindowCursor(FileRecHndl frHndl, WindowPtr window, Point globalPt);
void			PaletteWindowGoneFixup(WindowPtr window);



#endif
