#ifndef __LISTCONTROL__
#define __LISTCONTROL__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __LISTS__
#include <Lists.h>
#endif

#ifndef __WINDOWS__
#include <Windows.h>
#endif

typedef struct CLDataRec {
	short	txFont;
	Style	txFace;
	short	txMode;
	short	txSize;
	short	mode;
} CLDataRec;
typedef CLDataRec *CLDataPtr, **CLDataHndl;

void			CLInitialize(void);

void			CLActivate(Boolean active, ListHandle listHndl);
Boolean			CLClick(WindowPtr window, EventRecord *event, short *action);
ControlHandle	CLCtlHit(void);
Boolean			CLEvent(WindowPtr window, EventRecord *event, short *action);
ListHandle		CLFindActive(WindowPtr window);
ControlHandle	CLFindCtl(WindowPtr window, EventRecord *event, ListHandle *listHndl, ControlHandle *ctlHit);
ListHandle		CLFromScroll(ControlHandle scrollCtl, ControlHandle *retCtl);
ListHandle		CLGetList(WindowPtr window, short lnum);
short			CLInsert(ListHandle listHndl, char *data, short dataLen, short row, short col);
Boolean			CLKey(WindowPtr window, EventRecord *event);
ListHandle		CLNew(short viewID, Boolean vis, Rect *vRect, short numRows, short numCols, short cellHeight, short cellWidth, short theLProc, WindowPtr window, short mode);
ControlHandle	CLNext(WindowPtr window, ListHandle *listHndl, ControlHandle ctl, short dir, Boolean justActive);
void			CLPrint(RgnHandle clipRgn, ListHandle listHndl, short *row, short *col, short leftEdge, Rect *drawRct);
short			CLRowOrColSearch(ListHandle listHndl, char *data, short dataLen, short row, short col);
void			CLUpdate(RgnHandle clipRgn, ListHandle list);
ControlHandle	CLViewFromList(ListHandle listHndl);
ListHandle		CLWindActivate(WindowPtr window, Boolean displayIt);
void			CLSize(ListHandle list, short newH, short newV);
void			CLMove(ListHandle list, short newH, short newV);

typedef void			(*CLActivateProcPtr)(Boolean active, ListHandle listHndl);
typedef Boolean			(*CLClickProcPtr)(WindowPtr window, EventRecord *event, short *action);
typedef ControlHandle	(*CLCtlHitProcPtr)(void);
typedef ListHandle		(*CLFindActiveProcPtr)(WindowPtr window);
typedef Boolean			(*CLKeyProcPtr)(WindowPtr window, EventRecord *event);
typedef ControlHandle	(*CLNextProcPtr)(WindowPtr window, ListHandle *listHndl, ControlHandle ctl, short dir, Boolean justActive);
typedef ControlHandle	(*CLViewFromListProcPtr)(ListHandle listHndl);
typedef ListHandle		(*CLWindActivateProcPtr)(WindowPtr window, Boolean displayIt);

#define clHScroll		0x0002
#define clVScroll		0x0008
#define clActive		0x0020
#define clShowActive	0x0040
#define clKeyPos		0x0080
#define clTwoStep		0x0100
#define clHasGrow		0x0200
#define clDrawIt		0x8000

#endif

