#ifndef __TEXTEDITCONTROL__
#define __TEXTEDITCONTROL__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __TEXTEDIT__
#include <TextEdit.h>
#endif

#ifndef __TEXTSERVICES__
#include <TextServices.h>	
#endif

#ifndef	__TSMTE__
#include "TSMTE.h"
#endif

#ifndef __WINDOWS__
#include <Windows.h>
#endif

typedef Boolean	(*CTEKeyFilterProcPtr)(TEHandle teHndl, EventRecord *event, short *handled);
typedef Boolean	(*CTEFastKeysProcPtr)(TEHandle teHndl, EventRecord *event);

typedef struct CTEDataRec {
	short				maxTextLen;
	Boolean				newUndo;
	short				undoSelStart;
	short				undoSelEnd;
	Handle				undoText;
	StScrpHandle		undoStyl;
	short				mode;
	Rect				brdrRect;
	CTEKeyFilterProcPtr	keyFilter;
	CTEFastKeysProcPtr	fastKeys;
	TSMDocumentID		docID;
} CTEDataRec;
typedef CTEDataRec *CTEDataPtr, **CTEDataHndl;

void			CTEInitialize(void);

pascal void		ASMNOCARET(Rect *caretRect);
pascal Boolean	ASMTECLIKLOOP(void);
void			CTEActivate(Boolean active, TEHandle teHndl);
Boolean			CTEClick(WindowPtr window, EventRecord *event, short *action);
void			CTEClikLoop(void);
void			CTEClipboard(short menuID);
void			CTEConvertClipboard(Boolean convertClipboard, Boolean becomingActive);
pascal long		CTECtl(short varCode, ControlHandle ctl, short msg, long parm);
ControlHandle	CTECtlHit(void);
void			CTEDispose(TEHandle teHndl);
TEHandle		CTEDisposeView(ControlHandle viewCtl);
short			CTEDocHeight(TEHandle teHndl);
Boolean			CTEEditMenu(Boolean *activeItem, short editMenu, short undoID, short cutID);
Boolean			CTEEvent(WindowPtr window, EventRecord *event, short *action);
TEHandle		CTEFindActive(WindowPtr window);
ControlHandle	CTEFindCtl(WindowPtr window, EventRecord *event, TEHandle *teHndl,
						   ControlHandle *ctlHit);
TEHandle		CTEFromScroll(ControlHandle scrollCtl, ControlHandle *retCtl);
void			CTEHide(TEHandle teHndl);
void			CTEIdle(void);
short			CTEKey(WindowPtr window, EventRecord *event);
void			CTEMove(TEHandle teHndl, short newH, short newV);
OSErr			CTENew(short viewID, Boolean vis, WindowPtr window, TEHandle *teHndl, Rect *cRect,
					   Rect *dRect, Rect *vRect, Rect *bRect, short maxTextLen, short mode);
void			CTENewUndo(ControlHandle viewCtl, Boolean alwaysNewUndo);
ControlHandle	CTENext(WindowPtr window, TEHandle *teHndl, ControlHandle ctl, short dir, Boolean justActive);
short			CTENumTextLines(TEHandle teHndl);
OSErr			CTEPrint(TEHandle teHndl, short *offset, Rect *rct);
Boolean			CTEReadOnly(TEHandle teHndl);
ControlHandle	CTEScrollFromTE(TEHandle teHndl, Boolean vertScroll);
ControlHandle	CTEScrollFromView(ControlHandle viewCtl, Boolean vertScroll);
void			CTESetKeyFilter(TEHandle teHndl, CTEKeyFilterProcPtr proc);
void			CTESetFastKeys(TEHandle teHndl, CTEFastKeysProcPtr proc);
void			CTESetSelect(short start, short end, TEHandle teHndl);
void			CTEShow(TEHandle teHndl);
void			CTESize(TEHandle teHndl, short dx, short dy, Boolean newDest);
Handle			CTESwapText(TEHandle teHndl, Handle newText, StScrpHandle styl, Boolean update);
WindowPtr		CTETargetInfo(TEHandle *teHndl, Rect *teView);
void			CTEUndo(void);
void			CTEUpdate(TEHandle teHndl, ControlHandle ctl, Boolean justShowActive);
ControlHandle	CTEViewFromTE(TEHandle teHndl);
TEHandle		CTEWindActivate(WindowPtr window, Boolean displayIt);
void			CTEAdjustTEBottom(TEHandle teHndl);
void			CTEAdjustScrollValues(TEHandle teHndl);
StScrpHandle	CTEGetFullStylScrap(TEHandle teHndl);
void			CTESetStylScrap(short begRng, short endRng, StScrpHandle styles, TEHandle teHndl);
void			CTEGetPStr(ControlHandle ctl, StringPtr pstr);
void			CTESetPStr(ControlHandle ctl, StringPtr pstr);

Boolean			TSMTEAvailable(void);

typedef void			(*CTEActivateProcPtr)(Boolean active, TEHandle teHndl);
typedef Boolean			(*CTEClickProcPtr)(WindowPtr window, EventRecord *event, short *action);
typedef ControlHandle	(*CTECtlHitProcPtr)(void);
typedef TEHandle		(*CTEFindActiveProcPtr)(WindowPtr window);
typedef short			(*CTEKeyProcPtr)(WindowPtr window, EventRecord *event);
typedef ControlHandle	(*CTENextProcPtr)(WindowPtr window, TEHandle *teHndl, ControlHandle ctl, short dir, Boolean justActive);
typedef void			(*CTESetSelectProcPtr)(short start, short end, TEHandle teHndl);
typedef ControlHandle	(*CTEViewFromTEProcPtr)(TEHandle teHndl);
typedef TEHandle		(*CTEWindActivateProcPtr)(WindowPtr window, Boolean displayIt);

#define cteReadOnly			0x0001
#define cteHScroll			0x0002
#define cteHScrollLessGrow	0x0006
#define cteVScroll			0x0008
#define cteVScrollLessGrow	0x0018
#define cteActive			0x0020
#define cteNoBorder			0x0040
#define cteShowActive		0x0080
#define cteTabSelectAll		0x0100
#define cteTwoStep			0x0200
#define cteScrollFullLines	0x0400
#define cteStyledTE			0x0800
#define cteCenterJustify	0x1000
#define cteRightJustify		0x2000
#define cteNoFastKeys		0x4000
#define cteTSMTE			0x8000

#endif
